import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * clase a partir de la cual se crean las bolas de nieve que avientan los osos polares
 * 
 * @author Omar Espino  
 * @version 20/11/2014
 */

public class Bolanieve extends Obstaculo
{
    public final int DERECHA=1;
    public final int IZQUIERDA=0;
    private int direccion;
    
    /**constructor de la clase que se asigna la direccion*/
    /**@param recibe un entero int que es la direccion que tomara la bola de nieve para moverse*/
    public Bolanieve(int unaDireccion)
    {
        direccion=unaDireccion;
    }
    
    /**metodo principal de actuar de la bola de nieve*/
    public void act() 
    {
        movimiento();
    } 
    
    /**metodo para mover la bola de nieve hasta que llegue al personaje a alguna orilla*/
    public void movimiento()
    {
     if(isTouching(Ladrillo.class) || isTouching(Popo.class) || isTouching(Bloque.class) || isTouching(Baseizq.class)|| isTouching(Baseder.class))
     {
        getWorld().removeObject(this);   
     }
     else
     {
        if(direccion==IZQUIERDA)
        {
            setLocation(getX()+3,getY());
        }
        else
        {
            setLocation(getX()-3,getY());
        }
     }
    }
}
